fpga_interface/fpga_interface/urls.py
from django.contrib import admin
from django.urls import path

from django.conf.urls import url, include


urlpatterns = [
    path('admin/', admin.site.urls),
    path('login/', include(('login.urls', 'login'), namespace='login')),
    path('interface/', include(('interface.urls', 'interface'), namespace='interface')),
    path('output/', include(('output.urls', 'output'), namespace='output')),
]

fpga_interface/interface/urls.py
from django.urls import path
from . import views

app_name = 'interface'
urlpatterns = [
    path('', views.base_view, name="base"),
    path("logout/", views.logout_view, name="logout"),
    path("change_password/", views.change_password, name="changepw"),
    path("cluster_informations/", views.read_cluster_informations, name="clusterinformations"),
    path("connections_informations/", views.get_connections_infomations, name="connectionsinfromations"),
    path("network_settings/set/", views.set_network_params, name="network_set"),
    path("simulation/start/", views.start_simulation, name="simulation_start"),
    path("nestcode/", views.get_nest_code, name="nest_code"),
    path("setCode/", views.set_nest_code, name="set_code"),
]

fpga_interface/login/urls.py
from django.conf.urls import url
from . import views

app_name = 'login'
urlpatterns = [
	url("", views.login_view, name="login"),
]

fpga_interface/output/urls.py
from django.urls import path
from . import views

app_name = 'output'
urlpatterns = [
    path("", views.output_view, name="output"),
    path("download/", views.download_data, name="download"),
    path("statistics/", views.get_statistics, name="getstatistics"),
]

fpga_interface/output/models.py
from django.db import models

# Create your models here.

fpga_interface/output/views.py
from bz2 import compress
from django.http import HttpResponse, JsonResponse
from django.shortcuts import render
from django.contrib.auth.decorators import login_required
import mimetypes
import os
from pathlib import Path, PureWindowsPath

from io import BytesIO
import zipfile

from django.core.exceptions import ValidationError
from .validators import validate_statistic_input
from .validators import validate_download_input

FOLDER_PATH = Path.cwd().parents[0] / "textfiles"


@login_required
def output_view(request):
    return render(request, "output/base.html")

def create_zip(files_list: list):
    zip_filename = "output.zip"
    in_memory = BytesIO()

    compressor = zipfile.ZipFile(in_memory, "w")

    output_path = FOLDER_PATH / "output"
    
    print(type(compressor))

    for file in files_list:
        compressor.write(output_path / file, file)
    compressor.close()

    return in_memory

@login_required
def download_data(request):
    if request.method == "GET":
        request_data = request.GET
        try:
            validate_download_input(request_data)
        except ValidationError:
            return HttpResponse("Corrupt request", status=400)

        if len(request_data) == 0:
            return JsonResponse({}, status=204)

        requested_files = []

        for data in request_data.keys():
            if data == "results_plain":
                requested_files.append("read_spikes.txt")
            elif data == "results_binary":
                requested_files.append("spikes.bin")
            elif data == "metric_pr":
                requested_files.append("pr_output.txt")
            elif data == "metric_cv":
                requested_files.append("cv_output.txt")
            elif data == "metric_pc":
                requested_files.append("pc_output.txt")
            
        zip_file = create_zip(requested_files)

        resp = HttpResponse(zip_file.getvalue(), content_type = "application/x-zip-compressed", status= 200)
        resp["Content-Disposition"] = "attachment; filename=%s" % "output.zip"

        return resp
    return HttpResponse("Wrong method", status=405)

@login_required
def get_statistics(request):
    output_folder = FOLDER_PATH / "output"

    res = {};

    if request.method == "GET":
        stats = request.GET
        validate_statistic_input(stats)
        for element in stats.keys():
            if element == "PC":
                filename = output_folder / "pc_output.txt"
            elif element == "PR":
                filename = output_folder / "pr_output.txt"
            elif element == "CV":
                filename = output_folder / "cv_output.txt"
            else:
                raise ValueError("Not a statistic")

            with open(filename , "r") as file:
                data = file.read()
            res[element] = data
        return JsonResponse(res)
    return HttpResponse("wrong method", status=405)

"""
def get_spike_files():
    spike_files = []
    output_path = FOLDER_PATH / "output"
    if not output_path.is_dir():
        raise ValueError("{} is not a folder.".format(str(output_path)))    #XXX Better exception
    for file in output_path.iterdir():
        if "read_spikes_node" in file.name:
            spike_files.append(file.name)
    
    return spike_files

def get_downloadable_files():
    file_name_list = []

    output_path = FOLDER_PATH / "output"
    for file in output_path.iterdir():
        if (file.name.startswith("read_spikes") and not file.name.endswith(".bin")) or "output" in file.name or file.name.startswith("spikes"):
            file_name_list.append(file.name)

    print(file_name_list)"""

fpga_interface/output/templates/output/base.html
{% load static %}

<!doctype html>
<html lang="en">

    <head>
        <title>FPGA-Cluster Output</title>
        <meta charset="UTF-8">
        <meta name="author" content="Joachim Reif">
        
        <link href="{% static 'output/styles.css' %}" rel="stylesheet" type="text/css">
        <script src="{% static 'output/script.js'%}" type="module"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/3.7.0/chart.min.js" type="text/javascript"></script>

        <link rel="shortcut icon" href="#"> <!-- DELETE in production-->
    </head>

    <body>

        <header>
            <h1>FPGA-Cluster Output</h1>
            <a href="{% url 'interface:base' %}?type=std">Back</a>
        </header>

        <nav>
            <div id="data">
                <form method="GET" action="{% url 'output:download' %}">
                    <input type="checkbox" name="results_plain" id="r-plain">
                    <label for="r-plain">Results (Plaintext)</label>
                    <br>
                    <input type="checkbox" name="results_binary" id="r-binary">
                    <label for="r-binary"> Results (Binary)</label>
                    <br>
                    <input type="checkbox" name="metric_pr" id="m-pr">
                    <label for="m-pr">Pulse Rate</label>
                    <br>
                    <input type="checkbox" name="metric_cv" id="m-cv">
                    <label for="m-cv">Coefficient of Variation</label>
                    <br>
                    <input type="checkbox" name="metric_pc" id="m-pc">
                    <label for="m-pc">Pearson Correlation</label>

                    <input type="submit" value="Download" class="button-sidebar">
                </form>
            </div>
            <hr>
            <div id="statistics">
                <input type="checkbox" name="PR" id="stats_1">
                <label for="stats_1">Pulse Rate</label><br>
                <input type="checkbox" name="PC" id="stats_2">
                <label for="stats_2">Pearson Correlation</label><br>
                <input type="checkbox" name="CV" id="stats_3">
                <label for="stats_3">Coefficient of Variation</label>

                    <input type="button" value="Show statistics" class="button-sidebar">
            </div>
        </nav>

        <section>
            <!-- show statistics -->
        </section>

    </body>

</html>